LeetCode.160.Intersection of Two Linked Lists 两链表的交点
题目描述
160 Intersection of Two Linked Lists
https://leetcode-cn.com/problems/intersection-of-two-linked-lists/
Write a program to find the node at which the intersection of two singly linked lists begins.
For example, the following two linked lists:
begin to intersect at node c1.
Example 1:
Input: intersectVal = 8, listA = [4,1,8,4,5], listB = [5,0,1,8,4,5], skipA = 2, skipB = 3
Output: Reference of the node with value = 8
Input Explanation: The intersected node's value is 8 (note that this must not be 0 if the two lists intersect). From the head of A, it reads as [4,1,8,4,5]. From the head of B, it reads as [5,0,1,8,4,5]. There are 2 nodes before the intersected node in A; There are 3 nodes before the intersected node in B.
Example 2:
Input: intersectVal = 2, listA = [0,9,1,2,4], listB = [3,2,4], skipA = 3, skipB = 1
Output: Reference of the node with value = 2
Input Explanation: The intersected node's value is 2 (note that this must not be 0 if the two lists intersect). From the head of A, it reads as [0,9,1,2,4]. From the head of B, it reads as [3,2,4]. There are 3 nodes before the intersected node in A; There are 1 node before the intersected node in B.
Example 3:
Input: intersectVal = 0, listA = [2,6,4], listB = [1,5], skipA = 3, skipB = 2
Output: null
Input Explanation: From the head of A, it reads as [2,6,4]. From the head of B, it reads as [1,5]. Since the two lists do not intersect, intersectVal must be 0, while skipA and skipB can be arbitrary values.
Explanation: The two lists do not intersect, so return null.
Notes:
- If the two linked lists have no intersection at all, return null.
- The linked lists must retain their original structure after the function returns.
- You may assume there are no cycles anywhere in the entire linked structure.
- Your code should preferably run in O(n) time and use only O(1) memory.
解题过程
我的想法:
同时开始遍历两个链表,其中一个结束后开始计数,得到两个链表长度差m,此时也知道了哪个链表更长。
较长的链表先走m步,然后较短的链表开始,不断比较结点是否相等,遇到的第一个相等结点就是交点。
看了题解才知道 时间 O(n)
空间 O(1)
的解法,很巧妙,自己想不出来。
双指针法,分别从两个链表头部开始,消除长度差:
法一:每个指针走到结尾后跳到另一个链表头部继续,若有交点则第二次遍历肯定会相遇,若走完都没相遇,肯定无交点。
法二:第一个指针到达末端时,另一个与末端距离是两链表的长度差,记为d,此时也知道了哪个链表长。然后,长链表指针先走d步消除长度差,若有交点肯定相遇,否则不相遇。
private static class SolutionV2020 {
public ListNode getIntersectionNode(ListNode headA, ListNode headB) {
if (null == headA || null == headB) {
return null;
}
ListNode pA = headA, pB = headB;
// 双指针法,每个指针走到结尾后跳到另一个链表头部继续,消除长度差,若有交点则第二次遍历肯定会相遇
// 若走完都没相遇,肯定无交点
while (null != pA || null != pB) {
if (pA == pB) {
return pA;
}
pA = null != pA ? pA.next : headB;
pB = null != pB ? pB.next : headA;
}
return null;
}
}
GitHub代码
algorithms/leetcode/leetcode/_160_IntersectionOfTwoLinkedLists.java
https://github.com/masikkk/algorithms/blob/master/leetcode/leetcode/_160_IntersectionOfTwoLinkedLists.java
页面信息
location:
protocol
: host
: hostname
: origin
: pathname
: href
: document:
referrer
: navigator:
platform
: userAgent
: